<!--

Zoom redesign: we need separate selection from zooming

Needed buttons:

"Home" for zoom to full
"Zoom" for zoom to selection
"Zoom in/out" for zoom in/out

selection button: "square"
clear selection: "window-close"?

  -->

<template>
  <div
    class="d-flex align-items-baseline"
    style="position: relative"
  >
    <div id="d3-light-curve-chart" />
    <div style="display: block; position: relative; top: -5em">
      <div>
        <b-button
          v-b-tooltip.hover.right
          size="sm"
          variant="outline"
          title="Clear Selection"
          @click="clearBrush"
        >
          <font-awesome-icon
            :style="{ color: 'gray' }"
            :icon="['far', 'minus-square']"
          />
        </b-button>
      </div>
      <div>
        <b-button
          v-b-tooltip.hover.right
          size="sm"
          variant="outline"
          title="Zoom to Selection"
          @click="zoomToSelection"
        >
          <font-awesome-icon
            :style="{ color: 'gray' }"
            icon="crop-alt"
          />
        </b-button>
      </div>
      <div>
        <b-button
          v-b-tooltip.hover.right
          size="sm"
          variant="outline"
          title="Clear Zoom"
          @click="clearZoom"
        >
          <font-awesome-icon
            :style="{ color: 'gray' }"
            icon="search"
          />
        </b-button>
      </div>
      <div>
        <b-button
          v-b-tooltip.hover.right
          size="sm"
          variant="outline"
          title="Zoom In"
          @click="zoomIn"
        >
          <font-awesome-icon
            :style="{ color: 'gray' }"
            icon="search-plus"
          />
        </b-button>
      </div>
      <div>
        <b-button
          v-b-tooltip.hover.right
          size="sm"
          variant="outline"
          title="Zoom Out"
          @click="zoomOut"
        >
          <font-awesome-icon
            :style="{ color: 'gray' }"
            icon="search-minus"
          />
        </b-button>
      </div>
      <div>
        <b-button
          v-b-tooltip.hover.right
          size="sm"
          variant="outline"
          title="Export to PDF"
          @click="exportToPDF"
        >
          <font-awesome-icon
            :style="{ color: 'gray' }"
            icon="external-link-alt"
          />
        </b-button>
      </div>
    </div>
  </div>
</template>
<script>
/* eslint-disable no-underscore-dangle, eqeqeq, @typescript-eslint/no-this-alias,
  camelcase, no-restricted-globals
*/
import Vue from 'vue';
import * as d3 from 'd3';
import { LocusService } from '@/api';
import * as d3Utils from '@/vis/d3-utils';
import * as pdf from '@/vis/pdf';
import * as charts from '@/vis/chartTyped';

export default Vue.extend({
  props: {
    alerts: {
      type: Array,
      default: () => [],
    },
    locus: {
      type: Object,
      default: () => ({}),
    },
  },
  data() {
    return {
      chart: {
        width: 750,
        height: 500,
        marginTop: 10,
        marginBottom: 50,
        marginLeft: 50,
        marginRight: 10,
      },
      dataGroup: null,
      nearbyLoci: [],
    };
  },
  watch: {
    alerts() {
      // FIXME: we should call provideLocusData separately, but
      // I think the server is providing it to us
      // synchronously so there's no racing here

      charts.chartStore.commit('provideAlertsData', {
        group: 'default',
        data: this.alerts,
      });
      charts.chartStore.commit('provideLocusData', {
        group: 'default',
        data: this.validLightCurvePoints(),
      });
      // to begin with, we set the alert colors to be based on passband.
      this.annotateFillPassband();
      this.plot();
    },
  },
  mounted() {
    this.viewState = {
      timeAxis: 'mjd', // "mjd" || "cal"
    };

    this.d3Objects = {};

    this.createCharts();
    this.chartsUnwatch = charts.chartStore.watch(
      (state) => state.chartGroups.default.annotations.fill,
      () => {
        this.refreshCharts();
      },
    );
  },
  beforeDestroy() {
    this.chartsUnwatch();
  },
  methods: {
    exportToPDF() {
      pdf.createPDFReport();
    },
    validLightCurvePoints() {
      return this.locus.lightcurve.filter((d) => {
        if (d.frontend_magulim !== undefined && d.frontend_magulim < 0) return false;
        if (d.frontend_mag !== undefined && d.frontend_mag < 0) return false;
        if (d.frontend_magllim !== undefined && d.frontend_magllim < 0) return false;
        return true;
      });
    },
    setStartingScaleDomains() {
      const lightcurve = this.validLightCurvePoints();
      const { mag, mjd, cal } = this.scales();
      let mjdD = d3.extent(lightcurve, (d) => d.ant_mjd);
      if (mjdD[1] - mjdD[0] < 1) {
        const mean = (mjdD[1] + mjdD[0]) / 2;
        mjdD = [mean - 0.5, mean + 0.5];
      }
      mjd.domain(mjdD);

      const alertMagExtent = d3Utils.wideExtent(lightcurve, (d) => {
        const lst = [];
        if (d.frontend_mag) {
          lst.push(d.frontend_mag);
        }
        if (d.frontend_mag && d.frontend_magerr) {
          lst.push(d.frontend_mag + d.frontend_magerr);
          lst.push(d.frontend_mag - d.frontend_magerr);
        }
        if (d.frontend_magulim && d.frontend_magulim > 0) {
          lst.push(d.frontend_magulim);
        }
        if (d.frontend_magllim && d.frontend_magllim > 0) {
          lst.push(d.frontend_magllim);
        }
        return d3.extent(lst);
      });
      mag.domain(alertMagExtent);
      cal.domain(mjd.domain().map(charts.mjdToCal));

      // Extend scales a small amount to get some breathing room in the plot
      d3Utils.extendScaleDomain(mag, 1.1);
      d3Utils.extendScaleDomain(mjd, 1.1);
      d3Utils.extendScaleDomain(cal, 1.1);
    },
    timeAxisLegendText() {
      const df = d3.timeFormat('%Y-%m-%d');
      const name = this.viewState.timeAxis === 'cal' ? 'Calendar' : 'MJD';
      const { cal } = this.scales();
      const result = `Time (${name}) Range: (${df(cal.domain()[0])} — ${df(cal.domain()[1])})`;
      return result;
    },
    scales() {
      if (!this._mjdScale) {
        this._mjdScale = d3
          .scaleLinear()
          .range([this.chart.marginLeft, this.chart.width - this.chart.marginRight]);
        this._calScale = d3.scaleTime()
          .range(this._mjdScale.range());
        this._magScale = d3
          .scaleLinear()
        // mag is backwards, so this range() call looks goofy but is correct.
          .range([this.chart.marginTop + 30, this.chart.height - this.chart.marginBottom]);
        this._passbandScale = d3
          .scaleOrdinal()
          .domain(['g', 'R'])
          .range([d3.lab(50, -60, -10), d3.lab(40, 60, 30)]);
        // FIXME: this should be an application-global setting.
        // right now, we create two separate scales, one on AlertTypeLegend and another
        // one here. That's bug-prone.
        this._rcidScale = d3
          .scaleOrdinal()
          .range(d3.schemeCategory10);
      }
      return {
        cal: this._calScale,
        mjd: this._mjdScale,
        mag: this._magScale,
        passband: this._passbandScale,
        rcid: this._rcidScale,
        mark: charts.alertTypeMarkScale(),
      };
    },
    scaleLimits() {
      return {
        mjd: 1 / 24, // 1 hour minimum resolution
        mag: 0.01, // one hundredth magnitude minimum resolution
      };
    },
    async fetchNearbyLoci() {
      // TODO I believe we're redoing a search that already existed elsewhere;
      // should we consider caching these in LocusService?
      let { data: nearbyLoci } = await LocusService.coneSearch(
        `${this.locus.ra} ${this.locus.dec}`,
        1.5 / 3600.0,
        {
          page: {
            limit: 100,
          },
          fields: {
            locus_listing: 'ra,dec',
          },
        },
      );
      nearbyLoci = nearbyLoci.filter((locus) => locus.id != this.locus.id);
      this.nearbyLoci = nearbyLoci;
    },
    getSelectionDomain(getter, predicate, minRes) {
      const selectedAlerts = this.d3Objects.markGroups
        .filter((d) => predicate(d))
        .nodes()
        .map((n) => n.__data__);
      const result = d3Utils.wideExtent(
        selectedAlerts.filter((n) => getter(n) !== undefined),
        (d) => getter(d),
      );
      if (result[0] === result[1]) {
        return [result[0] - minRes / 2, result[1] + minRes / 2];
      }
      return result;
    },
    getBrushBounds() {
      const { mjd, mag } = this.scales();
      const sel = d3.brushSelection(this.d3Objects.brushGroup.node());
      if (sel) {
        return {
          mjd: [mjd.invert(sel[0][0]), mjd.invert(sel[1][0])],
          mag: [mag.invert(sel[0][1]), mag.invert(sel[1][1])],
        };
      }
      return { mjd: null, mag: null };
    },
    performZoomTransition(duration = 1000) {
      const { mjd, mag } = this.scales();
      function yCoord(d) {
        if (d.frontend_mag_type === 'ERROR_OTHER') {
          // FIXME this is the baseline height of the error view, we shouldn't hard-code it
          return 15;
        }
        return mag(d.getMag());
      }

      const transition = this.d3Objects.markGroups
        .transition()
        .duration(duration)
        .attr('transform', (d) => `translate(${mjd(d.payload.ant_mjd)},${yCoord(d)})`)
        .end();
      this.d3Objects.markGroups
        .selectAll('line')
        .transition()
        .duration(duration)
        .attr('y1', (d) => mag(d.payload.frontend_magerr) - mag(0))
        .attr('y2', (d) => mag(0) - mag(d.payload.frontend_magerr));
      this.d3Objects.mjdAxisG.transition().duration(duration).call(this.d3Objects.mjdAxis);
      // NOTE: in principle, we should be calling end(() => ...)  instead of on("end"). But end()
      // appears to be rejecting the promise for some reason I don't understand, and on("end")
      // works. shrug emoji here
      this.d3Objects.calAxisG.transition().duration(duration).call(this.d3Objects.calAxis).on('end', () => {
        this.d3Objects.timeAxisLegend.text(this.timeAxisLegendText());
      });
      this.d3Objects.magAxisG.transition().duration(duration).call(this.d3Objects.magAxis);
      return transition;
    },
    clearZoom() {
      this.setStartingScaleDomains();
      this.performZoomTransition();
    },
    clearSelection() {
      charts.chartStore.commit('predicate', {
        group: 'default',
        chartName: 'light-curve',
        predicate: null,
      });
      charts.triggerRedraw('default');
    },
    clearBrush() {
      this.clearSelection();
      this.d3Objects.brushGroup.call(this.d3Objects.brush.clear);
    },
    zoomToSelection() {
      const {
        mjd, mag, cal,
      } = this.scales();
      // getSelectionDomain depends on the domains of mjd and mag through predicate(),
      // and so we can't mutate mjd and mag until we've computed everything we need.
      // This is why we first store all values in local variables before assigning all
      // of them.
      const predicate = charts.getSelectionPredicate('default', null);
      const mjdDomain = this.getSelectionDomain(
        (n) => [n.payload.ant_mjd, n.payload.ant_mjd], predicate, this.scaleLimits().mjd,
      );
      const magDomain = this.getSelectionDomain(
        (n) => n.getWideMag(), predicate, this.scaleLimits().mag,
      );
      const brushBounds = this.getBrushBounds();

      mjd.domain(mjdDomain);
      cal.domain(mjd.domain().map(charts.mjdToCal));
      mag.domain(magDomain);
      d3Utils.extendScaleDomain(mjd, 1.1);
      d3Utils.extendScaleDomain(cal, 1.1);
      d3Utils.extendScaleDomain(mag, 1.1);
      this.performZoomTransition().then(() => {
        if (brushBounds.mjd !== null) {
          this.d3Objects.brush.move(
            this.d3Objects.brushGroup,
            [[mjd(brushBounds.mjd[0]), mag(brushBounds.mag[0])],
              [mjd(brushBounds.mjd[1]), mag(brushBounds.mag[1])]],
          );
        }
      });
    },
    zoomIn() {
      const {
        mjd, mag, cal,
      } = this.scales();
      // getSelectionDomain depends on the domains of mjd and mag through predicate(),
      // and so we can't mutate mjd and mag until we've computed everything we need.
      // This is why we first store all values in local variables before assigning all
      // of them.

      const mjdOldDomain = mjd.domain();
      const magOldDomain = mag.domain();

      const mjdMidPoint = (mjdOldDomain[1] + mjdOldDomain[0]) / 2;
      const magMidPoint = (magOldDomain[1] + magOldDomain[0]) / 2;

      const mjdHalfWidth = (mjdOldDomain[1] - mjdOldDomain[0]) / 2;
      const magHalfWidth = (magOldDomain[1] - magOldDomain[0]) / 2;

      const brushBounds = this.getBrushBounds();
      mjd.domain([mjdMidPoint - mjdHalfWidth / 1.5, mjdMidPoint + mjdHalfWidth / 1.5]);
      cal.domain(mjd.domain().map(charts.mjdToCal));
      mag.domain([magMidPoint - magHalfWidth / 1.5, magMidPoint + magHalfWidth / 1.5]);
      this.performZoomTransition(500).then(() => {
        if (brushBounds.mjd !== null) {
          this.d3Objects.brush.move(
            this.d3Objects.brushGroup,
            [[mjd(brushBounds.mjd[0]), mag(brushBounds.mag[0])],
              [mjd(brushBounds.mjd[1]), mag(brushBounds.mag[1])]],
          );
        }
      });
    },
    zoomOut() {
      const {
        mjd, mag, cal,
      } = this.scales();
      // getSelectionDomain depends on the domains of mjd and mag through predicate(),
      // and so we can't mutate mjd and mag until we've computed everything we need.
      // This is why we first store all values in local variables before assigning all
      // of them.

      const mjdOldDomain = mjd.domain();
      const magOldDomain = mag.domain();

      const mjdMidPoint = (mjdOldDomain[1] + mjdOldDomain[0]) / 2;
      const magMidPoint = (magOldDomain[1] + magOldDomain[0]) / 2;

      const mjdHalfWidth = (mjdOldDomain[1] - mjdOldDomain[0]) / 2;
      const magHalfWidth = (magOldDomain[1] - magOldDomain[0]) / 2;

      const brushBounds = this.getBrushBounds();
      mjd.domain([mjdMidPoint - mjdHalfWidth * 1.5, mjdMidPoint + mjdHalfWidth * 1.5]);
      cal.domain(mjd.domain().map(charts.mjdToCal));
      mag.domain([magMidPoint - magHalfWidth * 1.5, magMidPoint + magHalfWidth * 1.5]);
      this.performZoomTransition(500)
        .then(() => {
          if (brushBounds.mjd !== null) {
            this.d3Objects.brush.move(
              this.d3Objects.brushGroup,
              [[mjd(brushBounds.mjd[0]), mag(brushBounds.mag[0])],
                [mjd(brushBounds.mjd[1]), mag(brushBounds.mag[1])]],
            );
          }
        });
    },
    createCharts() {
      const svg = d3
        .select('#d3-light-curve-chart')
        .append('svg')
        .attr('width', this.chart.width)
        .attr('height', this.chart.height);
      const defs = svg
        .append('defs');
      charts.chartStore.commit('createChartGroup', 'default');
      charts.chartStore.commit('predicate', {
        group: 'default',
        chartName: 'light-curve',
        predicate: null,
      });

      const scales = this.scales();
      const {
        cal, mjd, mag,
      } = scales;
      defs.append('clipPath')
        .attr('id', 'light-curve-chart-clip')
        .append('rect')
        .attr('y', Math.min(scales.mag.range()[0], scales.mag.range()[1]))
        .attr('height', Math.abs(scales.mag.range()[0] - scales.mag.range()[1]))
        .attr('x', Math.min(scales.mjd.range()[0], scales.mjd.range()[1]))
        .attr('width', Math.abs(scales.mjd.range()[0] - scales.mjd.range()[1]));
      this.setStartingScaleDomains();

      this.d3Objects.brushGroup = svg.append('g');
      const aG = svg.append('g');
      aG.append('g')
        .attr('transform', `translate(${mjd(mjd.domain()[0])}, 15)`)
        .attr('class', 'tick')
        .append('text')
        .attr('fill', 'currentcolor')
        .attr('text-anchor', 'end')
        .attr('dominant-baseline', 'middle')
        .text('errors:');

      const magAxis = d3.axisLeft(mag);
      magAxis.ticks(5);

      const magAxisG = aG.append('g')
        .attr('transform', `translate(${mjd(mjd.domain()[0])}, 0)`)
        .call(magAxis);
      this.d3Objects.magAxis = magAxis;
      this.d3Objects.magAxisG = magAxisG;

      const mjdAxis = d3.axisBottom(mjd);
      mjdAxis.ticks(10);
      const mjdAxisG = aG.append('g')
        .attr('transform', `translate(0, ${mag(mag.domain()[1])})`)
        .call(mjdAxis);
      this.d3Objects.mjdAxis = mjdAxis;
      this.d3Objects.mjdAxisG = mjdAxisG;

      const calAxis = d3.axisBottom(cal);
      this.d3Objects.calAxis = calAxis;

      calAxis.ticks(10);
      const calAxisG = aG.append('g')
        .attr('transform', `translate(0, ${mag(mag.domain()[1])})`)
        .attr('visibility', 'hidden')
        .call(calAxis);
      this.d3Objects.calAxisG = calAxisG;

      const timeAxisLegend = aG.append('g')
        .append('text')
        .text(this.timeAxisLegendText())
        .attr('text-anchor', 'middle')
        .attr('dominant-baseline', 'hanging')
        .attr('x', mjd((mjd.domain()[0] + mjd.domain()[1]) / 2))
        .attr('y', mag(mag.domain()[1]) + 30)
        .attr('cursor', 'pointer');
      this.d3Objects.timeAxisLegend = timeAxisLegend;
      timeAxisLegend.on('click', () => {
        if (this.viewState.timeAxis === 'cal') {
          calAxisG.attr('visibility', 'hidden');
          mjdAxisG.attr('visibility', null);
          this.viewState.timeAxis = 'mjd';
        } else {
          calAxisG.attr('visibility', null);
          mjdAxisG.attr('visibility', 'hidden');
          this.viewState.timeAxis = 'cal';
        }
        timeAxisLegend.text(this.timeAxisLegendText());
      });

      aG.append('g')
        .append('text')
        .text('Magnitude')
        .attr(
          'transform',
          `rotate(-90, ${mjd(mjd.domain()[0])}, ${mag((mag.domain()[0] + mag.domain()[1]) / 2)})`,
        )
        .attr('text-anchor', 'middle')
        .attr('x', mjd(mjd.domain()[0]))
        .attr('y', mag((mag.domain()[0] + mag.domain()[1]) / 2) - 30);

      this.d3Objects.dataGroup = svg.append('g')
        .attr('clip-path', 'url(#light-curve-chart-clip)');
    },
    setMarkColor(sel) {
      const disabledColor = 'rgba(192, 192, 192, 1)';
      const state = charts.chartStore.state.chartGroups.default;
      let f;
      if (!state.annotations.fill) {
        f = () => disabledColor;
      } else {
        f = (d) => {
          const id = d.payload.alert_id;
          return state.annotations.fill.get(id) || disabledColor;
        };
      }
      sel.attr('stroke', f).attr('fill', f);
    },
    refreshCharts() {
      this.d3Objects.dataGroup.selectAll('g')
        .call(this.setMarkColor);
    },
    annotateFillPassband() {
      const { passband } = this.scales();
      const colorAnnotation = new Map();
      const store = charts.chartStore;
      store.state.chartGroups.default.alertsData.forEach((d) => {
        colorAnnotation.set(d.id, passband(d.properties.ant_passband));
      });
      store.state.chartGroups.default.locusData.forEach((d) => {
        colorAnnotation.set(d.alert_id, passband(d.ant_passband));
      });
      charts.chartStore.commit('annotate', {
        group: 'default',
        key: 'fill',
        annotation: colorAnnotation,
      });
    },
    annotateFillRcid() {
      const { rcid } = this.scales();
      const colorAnnotation = new Map();
      const disabledColor = 'rgba(192, 192, 192, 1)';
      // the sequencing beteen locusData and alertsData matters here
      // locusData sometimes includes alertsData ids as well, so we need
      // to make sure alertsData takes precedence (so those colors are set last.)
      const store = charts.chartStore;
      store.state.chartGroups.default.locusData.forEach((d) => {
        colorAnnotation.set(d.alert_id, disabledColor);
      });
      store.state.chartGroups.default.alertsData.forEach((d) => {
        colorAnnotation.set(d.id, rcid(d.properties.ztf_rcid));
      });
      charts.chartStore.commit('annotate', {
        group: 'default',
        key: 'fill',
        annotation: colorAnnotation,
      });
    },
    colorByPassband() {
      if (d3.select('#alert-legend-rcid-text').nodes().length) {
        d3.select('#alert-legend-passband-text')
          .style('font-weight', 700);
        d3.select('#alert-legend-rcid-text')
          .style('font-weight', null);
      }
      this.annotateFillPassband();
    },
    colorByRcid() {
      if (d3.select('#alert-legend-rcid-text').nodes().length) {
        d3.select('#alert-legend-passband-text')
          .style('font-weight', null);
        d3.select('#alert-legend-rcid-text')
          .style('font-weight', 700);
      }
      this.annotateFillRcid();
    },
    populateCharts() {
      if (d3.select('#alert-legend-rcid-text').nodes().length) {
        d3.select('#alert-legend-passband-text')
          .on('click', () => this.colorByPassband());
        d3.select('#alert-legend-rcid-text')
          .on('click', () => this.colorByRcid());
        d3.select('#alert-legend-passband-text')
          .style('font-weight', 700);
      }

      const scales = this.scales();
      const {
        mjd, mag, mark, rcid,
      } = scales;

      // force calling the scale in the correct order to populate values
      const that = this;
      const rcid_set = () => {
        const result = new Set();
        this.alerts.forEach((d) => {
          if (d.properties.ztf_rcid !== undefined) {
            result.add(d.properties.ztf_rcid);
          }
        });
        return result;
      };

      const rcids = Array.from(rcid_set());
      rcids.sort((a, b) => a - b);
      rcids.forEach((v) => rcid(v));

      if (rcids.length > 1) {
        d3.select('#choose-color')
          .style('display', null);
      }

      /// /////////////////////////////////////////////////////////////////////////////
      // This creates all marks for the light curve plot
      //
      // each alert can generate one of these possibilities
      // if alert is raw, then it will only have mag and magerr
      // if alert is raw_maglim, then it will only have mag_ulim
      // if alert is calibrated, then it will only have mag and magerr
      // if alert is calibrated_maglim, then it will have mag_ulim and mag_llim

      const lightcurve = charts.chartStore.state.chartGroups.default.locusData;
      const mags = lightcurve.filter(
        (d) => (d.frontend_mag_type === 'raw'
              || d.frontend_mag_type === 'calibrated'),
      );
      const rawMaglims = lightcurve.filter(
        (d) => d.frontend_mag_type === 'raw_maglim',
      );
      const calibratedMaglims = lightcurve.filter(
        (d) => d.frontend_mag_type === 'calibrated_maglim',
      );

      function createTransformedGroup(ar, keyFun) {
        function yCoord(d) {
          if (d.payload.frontend_mag_type === 'ERROR_OTHER') {
            // FIXME this is the baseline height of the error view, we shouldn't hard-code it
            return 15;
          }
          return mag(d.getMag());
        }
        return that.d3Objects.dataGroup
          .selectAll('g')
          .data(ar, keyFun)
          .enter()
          .append('g')
          .attr('transform', (d) => `translate(${mjd(d.payload.ant_mjd)},${yCoord(d)})`);
      }
      function createMagMark(data) {
        const marks = createTransformedGroup(data, (d) => d.alert_id + d.type, 'frontend_mag');
        // we set color on the group so that we can treat mags and lims uniformly wrt color
        marks.call(that.setMarkColor);
        // error bar
        marks.filter((d) => d.payload.frontend_magerr)
          .append('line')
          .attr('x1', 0)
          .attr('x2', 0)
          .attr('y1', (d) => mag(d.payload.frontend_magerr) - mag(0))
          .attr('y2', (d) => mag(0) - mag(d.payload.frontend_magerr));
        // alert
        marks
          .append('path')
          .attr('d', mark('raw'));
      }

      /*
        Ok, this is ugly.

        the fundamental problem which exists here is that we need to create more than one
        mark for each datum inside the main group. It's hard to do that directly in d3,
        and so we hack this by "enriching" the data, creating new objects with fields
        'payload' and 'type' below, so they can have all different keys.
      */
      function createMaguLimMark(data) {
        const marks = createTransformedGroup(data, (d) => d.payload.alert_id + d.type, 'frontend_magulim');
        marks.call(that.setMarkColor);
        marks
          .append('path')
          .attr('d', mark('upper_limit'));
      }
      function createMaglLimMark(data) {
        const marks = createTransformedGroup(data, (d) => d.payload.alert_id + d.type, 'frontend_magllim');
        marks.call(that.setMarkColor);
        marks
          .append('path')
          .attr('d', mark('lower_limit'));
      }

      createMagMark(mags.map((d) => ({
        payload: d,
        type: 'mag',
        getWideMag() {
          if (d.frontend_mag && d.frontend_magerr) {
            return [d.frontend_mag - d.frontend_magerr,
              d.frontend_mag + d.frontend_magerr];
          } // if (d.frontend_mag) {
          return [d.frontend_mag, d.frontend_mag];
        },
        getMag() {
          return this.payload.frontend_mag;
        },
      })));
      createMaguLimMark(rawMaglims
        .map((d) => ({
          payload: d,
          type: 'ulim',
          getWideMag() {
            return [d.frontend_magulim, d.frontend_magulim];
          },
          getMag() {
            return this.payload.frontend_magulim;
          },
        })));
      createMaguLimMark(calibratedMaglims
        .map((d) => ({
          payload: d,
          type: 'ulim',
          getWideMag() {
            return [d.frontend_magulim, d.frontend_magulim];
          },
          getMag() {
            return this.payload.frontend_magulim;
          },
        })));
      createMaglLimMark(calibratedMaglims
        .filter((d) => !isNaN(d.frontend_magllim))
        .map((d) => ({
          payload: d,
          getWideMag() {
            return [d.frontend_magllim, d.frontend_magllim];
          },
          type: 'llim',
          getMag() {
            return this.payload.frontend_magllim;
          },
        })));

      const markGroups = this.d3Objects.dataGroup.selectAll('g');
      this.d3Objects.markGroups = markGroups;

      charts.watchBrush('default', () => {
        const predicate = charts.getSelectionPredicate('default', 'light-curve');
        markGroups
          .filter((d) => predicate(d))
          .style('opacity', null);
        markGroups.filter((d) => !predicate(d)).style('opacity', 0.1);
      });

      function brushed(event) {
        if (event.selection) {
          const [[x0, y0], [x1, y1]] = event.selection;
          const [xMin, xMax] = d3.extent([x0, x1]);
          const [yMin, yMax] = d3.extent([y0, y1]);
          charts.chartStore.commit('predicate', {
            group: 'default',
            chartName: 'light-curve',
            predicate: (d) => {
              const magValue = d.getMag();
              const mjdValue = d.payload.ant_mjd;

              // FIXME double-check here
              if (!mjdValue || !magValue) {
                return false;
              }

              return (xMin <= mjd(mjdValue)
                      && mjd(mjdValue) <= xMax
                      && yMin <= mag(magValue)
                      && mag(magValue) <= yMax);
            },
          });
          charts.triggerRedraw('default');
        } else {
          that.clearSelection();
        }
      }

      this.d3Objects.brush = d3.brush().on('start brush end', brushed);
      this.d3Objects.brushGroup.attr('class', 'brush').call(this.d3Objects.brush);

      this.fetchNearbyLoci();
    },
    plot() {
      this.populateCharts();
    },
  },
});
</script>
